#ifndef CONTEXT_H
#define CONTEXT_H

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#define EPSILON 0.00001
#ifndef MIN
#define MIN(x,y) ((x)<(y)?(x):(y))
#endif
#ifndef MAX
#define MAX(x,y) ((x)>(y)?(x):(y))
#endif
#define BUFLEN 4096

struct context;
#include "node.h"
#include "toposerver.h"
#include "pqueue.h"

typedef struct context {
	int nNodes;
	struct node **nodes;
	int statePerNode;
	unsigned long seed;
	toposerver *ts;
	int tsState;	// amount of state at the toposerver
	FILE * logfile;	// where all of the output goes
	FILE * statfile;// where all of the stat info goes
	pqueue *pq;	// discrete event Queue
	double now;	// the current SIM time
	int maxTransactionsRule;
	char configFileName[BUFLEN];
	int useLogFile;
	int maxbad;
	int nRounds;
	int curRound;
	int nSatisfied;
	int nFailed;
	int nFailedJobs;
	int jobsDropped;
	int totJobs;
	int cookieProtocol;
	int MaxQueryHopCount;
	int CookieSearchExpansionFactor;
	int charity;
	double stopAt;	// used to debug sim
	double endAt;	// used to end sim
	double backoffProb;
	int maxQueries;
	double failTime;
	int doneCount;
	int totGood;
} context;

context * context_create();

#endif
