
#include <stdlib.h>
#include <assert.h>

#include "event.h"
#include "pqueue.h"

void event_free(event *e){
	if(e->arg!=NULL)
		free(e->arg);
	free(e);
}


/********************************************************************
 * int event_create(context *,eventfunct, int src_id, int id, void * arg, double t);
 * 	malloc, fill in, and schedule an event
 *
 */
int event_create(context * ctx,eventfunct f, int src_id, int id, void * arg, double t){
	event *e;

	e=malloc(sizeof(event));
	assert(e);
	e->fun=f;
	e->src_id=src_id;
	e->id=id;
	e->arg=arg;
	e->t=t;
	pqueue_insert(ctx->pq,e,t);
	return 0;
}


