#ifndef HISTORY_H
#define HISTORY_H

struct history;
#include "node.h"

typedef struct history {
	int id;
	double trust;
	int nInteractions;
	int nGood;
	int transWindow;
	int badguy;
	int blocksStored;
	int shouldQuery;
	void * savedGetRequest;
//	int gotGoodCookie;	; don't need anymore
} history;

history * history_create(int id);
void history_free(history *);
int history_update(struct context * ctx, int src_id, int dst_id, int result);
int history_add(struct context * ctx, int src_id, int dst_id);
int history_add_with_trust(struct context * ctx, int src_id, int dst_id, double trust);
int history_remove(struct context * ctx, int src_id, int dst_id);
int history_set_resp(struct context * ctx, int src_id, int dst_id, int resp);
int history_set_abs_resp(struct context * ctx, int src_id, int dst_id, int resp);
int history_get_resp(struct context * ctx, int src_id, int dst_id);
int history_get_max_transactions(struct context *, history *);
int histories_sort_by_trust(struct context * ctx, struct node *);
history * history_lookup(struct context *ctx, int id, int dst_id);
int history_flush_and_refill(struct context *, int id);
int history_good_cookie_count(struct context *ctx, int id);


#endif
