#include <stdlib.h>
#include <assert.h>
#include <string.h>

#include "query.h"
#include "context.h" // for MIN def

getquery * getquery_create(int init_want,int resp_want){
	getquery *  gq;

	gq= malloc(sizeof(getquery));
	assert(gq);
	gq->init_want=init_want;
	gq->resp_want=resp_want;
	gq->nAdvertised=0;
	gq->hopcount=0;
	gq->queryid=-1;
	gq->cookiePathLen=0;
	return gq;
}

/*****************************************************
 * getquery * getquery_copy(getquery *)
 *	just dup the struct
 */

getquery * getquery_copy(getquery *gq){
	getquery *resp;
	resp = malloc(sizeof(getquery));
	memcpy(resp,gq,sizeof(getquery));
	return resp;
}
/***************************************************************
 * getquery_advertise: 
 * 	add nodes ids into the query to help inform nodes
 * 	of new nodes
 */

int getquery_advertise(getquery *gq, int id){
	if(gq->nAdvertised<MAXADVERTISE)
		gq->advertise[gq->nAdvertised++]=id;
	else return -1;
	return 0;
}

/***************************************************************
 * getquery_get_advertised:
 * 	return a list of advertised nodes
 */

int getquery_get_advertised(getquery * gq, int * list , int *len){
	*len=MIN(*len,gq->nAdvertised);
	memcpy(list,gq->advertise,*len * sizeof(int));
	return *len;
}

/*************************************************************
 * checkquery_create:
 * 	malloc a checking query
 */

checkquery * checkquery_create(int src_id, int nBlocks){
	checkquery *cq;

	cq = malloc(sizeof(checkquery));
	assert(cq);
	cq->src_id=src_id;
	cq->nBlocks=nBlocks;
	return cq;
}

/*************************************************************
 * getquery_advertise_reset()
 * 	restart with no ads
 */
void getquery_advertised_reset(getquery *gq){
	assert(gq);
	gq->nAdvertised=0;
}

/************************************************************
 * int getquery_mark_visited(getquery *,int);
 * 	mark in the query that we have visited this node
 */
int getquery_mark_visited(getquery * gq,int id){
	assert(gq);
	gq->loopList[gq->cookiePathLen]=id;	// assume we have one hop/cookie addition
						// ... sound reasonable
	return 0;
}


/************************************************************
 * int getquery_already_visited(getquery *,int);
 * 	return 1 if id is in visited list
 */
int getquery_already_visited(getquery * gq,int id){
	int i;
	assert(gq);
	for(i=0;i<gq->cookiePathLen;i++){	// assume we have one hop/cookie addition
		if(gq->loopList[i]==id)
			break;			// ... sound reasonable
	}
	if(i<gq->cookiePathLen)
		return 1;
	return 0;
}

