#ifndef QUERY_H
#define QUERY_H

#define MAXADVERTISE 10

struct getquery;

#include "truststore.h"

typedef struct getquery {
	int init_want;
	int resp_want;
	int advertise[MAXADVERTISE];
	int nAdvertised;
	struct trustcookie cookiePath[MAXADVERTISE];
	int loopList[MAXADVERTISE];
	int cookiePathLen;
	int src_id;
	int dst_id;
	int queryid;
	int hopcount;
} getquery;

getquery * getquery_create(int,int);
getquery * getquery_copy(getquery*);
int getquery_advertise(getquery *, int id);
int getquery_get_advertised(getquery * gq, int * list , int *len);
void getquery_advertised_reset(getquery *gq);
int getquery_already_visited(getquery *,int);
int getquery_mark_visited(getquery *,int);


typedef struct checkquery{
	int src_id;
	int nBlocks;
} checkquery;

checkquery * checkquery_create(int src_id, int nBlocks);

#endif
