#ifndef TRUSTSTORE_H
#define TRUSTSTORE_H

struct truststore;

struct context;


#define GOODCOOKIETHRESH 0.5

typedef struct trustcookie {
	int src_id;
	int dst_id;
	double val;
	int nTransactions;
	int nGoodTransactions;
	struct trustcookie * left, *right;
} trustcookie;

typedef struct truststore {
	trustcookie *root;
	int nodes;
} truststore;

#include "query.h"
#include "event.h"

truststore * truststore_create();
int truststore_add(truststore*,trustcookie *);
int truststore_exists(truststore*,int);
int truststore_count(truststore*);
trustcookie * truststore_lookup(truststore*,int id);
int truststore_remove(truststore*,int id);
trustcookie * trustcookie_create(int,int,double,int,int);
int truststore_get_list(truststore *, trustcookie **, int *);

int trustcookie_cmp(trustcookie *, trustcookie *);

void truststore_print(trustcookie *,int,FILE *);


int cookie_give(struct context *, int src, int dst,int good);
int cookie_store_bad(struct context *, int src, int dst,int good);
double trust_calc_cookie_path(struct context *,int,struct getquery *gq);
int trust_calc_forw_cookie_path(struct context *, int src, int dst,struct getquery *gq);
int trust_calc_back_cookie_path(struct context *, int src, int dst);

int trust_update_best_path(trustcookie *,int *,struct getquery *);

void trust_cookielookup(struct context *, struct event *, double t);
void trust_cookiereturn(struct context *, struct event *, double t);

int do_truststore_tests();	// unit testing

#endif
